/*
  Copyright (C) 1999 Rainer Maximini

  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation.

  For more information look at the file COPYRIGHT in this package
*/


#ifndef CONFIGABOUT_H
#define CONFIGABOUT_H

#include <kconfig.h>
#include <qwidget.h>
#include <qlabel.h>
#include <qstring.h>
#include <qpixmap.h>
#include <qgroupbox.h>
#include "configfolder.h"


class ConfigAbout: public QWidget
{
    Q_OBJECT
 public:
  ConfigAbout(QWidget *parent=0, const char *name=0);
  ~ConfigAbout();
 protected:
  void resizeEvent (QResizeEvent *);
 private:  
  QGroupBox *box;
  QLabel    *copyright;
  QLabel    *author;
  QLabel    *hometext;
  QLabel    *logo;
  const QPixmap *logoPix;
  
 public slots:
  void cancel();
  void accept();
};

#endif // EINSTELLUNGEN_H

